unit WMain;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, StdCtrls,
  windows, shlobj, comobj;

type

  { TWnd_Test }

  TWnd_Test = class(TForm)
    Btn_AddTab: TButton;
    Btn_DeleteTab: TButton;
    Edt_AppTitle: TEdit;
    Label1: TLabel;
    procedure Btn_AddTabClick(Sender: TObject);
    procedure Btn_DeleteTabClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    FTaskbar: ITaskbarList3;
  public

  end;

var
  Wnd_Test: TWnd_Test;

implementation

{$R *.lfm}

{ TWnd_Test }

procedure TWnd_Test.FormShow(Sender: TObject);
begin
	Edt_AppTitle.Text := Application.Title;
	FTaskbar := CreateComObject(CLSID_TaskbarList) as ITaskbarList3;
	FTaskbar.HrInit;
end;

procedure TWnd_Test.Btn_AddTabClick(Sender: TObject);
var
	h: HWND;
begin
	h := FindWindow(nil, LPCSTR(Edt_AppTitle.Caption));
	if h <> INVALID_HANDLE_VALUE then begin
    FTaskbar.AddTab(h);
    // um zu zeigen dass Form und Taskbar Item ein unterschiedliches Handle haben:
  	Caption := 'Form: ' + IntToStr(Handle) + ' | Taskbar Item: ' + IntToStr(h);
	end;
end;

procedure TWnd_Test.Btn_DeleteTabClick(Sender: TObject);
var
	h: HWND;
begin
	h := FindWindow(nil, LPCSTR(Edt_AppTitle.Caption));
	if h <> INVALID_HANDLE_VALUE then begin
    FTaskbar.DeleteTab(h);
    // um zu zeigen dass Form und Taskbar Item ein unterschiedliches Handle haben:
  	Caption := 'Form: ' + IntToStr(Handle) + ' | Taskbar Item: ' + IntToStr(h);
	end;
end;

end.

